/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1993  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

/* define varie */
#define		maxOpenEyeballWindows	8   /* otto finestre al piu' */
#define		maxSounds				8	/* al pi 8 suoni per fare bua */
#define		sysEnvironsVersion		1
#define		osEvent					app4Evt
#define		suspendResumeMessage	1
#define		resumeMask				1
#define		mouseMovedMessage		0xFA
#define		eraseOnly				1
#define		drawOnly				2
#define		eraseAndDraw			0
#define		iniziata				true
#define		finita					false


/* risorse varie */
#define		rMenuBar		128
#define		rAboutAlert		128
#define		rCouldNotLoadSound 129
#define		rNotEnoughMemory 130
#define		rHelpAlert		131
#define		rPrefsFileProblem	132
#define		rPrefsFileDamaged	133
#define		rEyesWindow		128

/* ID dei menu' e degli item */
#define		mApple		128
#define		iAbout		1
#define		iHelp		2

#define		mFile		129
#define		iNew		1
#define		iClose		2
#define		iSave		3
#define		iQuit		4

#define		mColors		130
#define		iPupilla	1
#define		iGlobo		2
#define		iBordo		3
#define		iSfondo		4

#define		mWindows	131
#define		iSendBack	1

/*	v 2.1 changes	*/
#define		MAXHEIGHT	480
#define		MAXWIDTH	640
#define		MINHEIGHT	15
#define		MINWIDTH	30

/* tipi di dati miei */
typedef struct {
	Point			old;
	Point			new;
} PointCouple, *PCouplePtr;

typedef struct {
	RGBColor		sfondo;
	RGBColor		pupilla;
	RGBColor		bordo;
	RGBColor		globo;
}	RGBQuartette;	//	i keep this structure because the old preferences file
					//	can be reused

typedef struct {
	WindowRecord	window;
	RGBQuartette	colori;
	PointCouple		left;		/*	old and bew positions of the pupils in the window */
	PointCouple		right;
	Rect			globeRect;	/*	eye globe enclosing rectangle */
	Rect			eyeRect;	/*	rectangle of the whole eye */
	Point			pupilRay;	/*  pupil dimensions */
	Point			rectDim;	/*	window dimensions */
	char			inPupilla;	/*	the pointer is  0 -> on no pupil	*/
								/*					1 -> left one 		*/
								/*					2 -> right one		*/
	char			posizione;	/*	if sleeping in [1-16] . 0 = awake	*/
	short			offset;		/*	how many pixels is the right eye to the right of the left one ? */
} EyesRecord, *EyesPeek;

typedef struct {
	Rect			rect;
	RGBQuartette	colori;
}	eYeSWinData, *eYeSWinPeek;

#define	sfondoColor  colori.sfondo
#define	pupillaColor colori.pupilla
#define	bordoColor   colori.bordo
#define	globoColor   colori.globo

typedef struct {
	short			valore;	/* non usato per ora */
	short			quante; /* quante finestre */
	eYeSWinData		eYeSWin[maxOpenEyeballWindows];
}	eYeSResource, *eYeSPeek, **eYeSHandle;

typedef struct {
	Handle		aSound[1];
}	bunchOfSounds, *bunchOfSoundsPtr, **bunchOfSoundsHandle;

typedef pascal WindowPtr (NewWindowProc) (Ptr storage,Rect * boundsRectPtr,
		ConstStr255Param title, Boolean visible,short procID,WindowPtr behind,
		Boolean goAwayFlag,long refCon);
typedef	NewWindowProc	*NewWindowProcPtr;
// :-)

/* Macro I KNOW THIS IS FOOLISH BUT I HAVE BEEN SIMPLY EXPERIMENTING */
#define myHiWrd(aLong,theShort)		\
		move.l	aLong,d0			\
		swap	d0					\
		move.w	d0,theShort			

#define	myLoWrd(aLong,theShort)		\
		move.l	aLong,d0			\
		move.w	d0,theShort

#define NextWindow(window)	((WindowPtr) (((WindowPeek) window)->nextWindow))

//	i do it just for fun and to complicate my life
//	think C could do it by itself, just as gcc does
#define TIMES15(A) ( ((A)<<4) - (A) )
#define TIMES7(A) ( ((A)<<3) - (A) )

/* utilita' varie per manipolare punti e rettangoli */
#define TOPLEFT(R) ((Point *)(&(R)->top))
#define BOTRIGHT(R) ((Point *)(&(R)->bottom))
#define SETPT(P,H,V) {(P)->h=H;(P)->v=V;}
#define SETRECT(S,L,T,R,B) {SETPT(TOPLEFT(S),L,T);SETPT(BOTRIGHT(S),R,B);}
#define OFFSETPT(P,H,V) {(P)->h+=H;(P)->v+=V;}
#define OFFSETRECT(R,H,V) {OFFSETPT(TOPLEFT(R),H,V);OFFSETPT(BOTRIGHT(R),H,V);}
#define INSETRECT(R,H,V) {OFFSETPT(TOPLEFT(R),H,V);OFFSETPT(BOTRIGHT(R),-H,-V);}
#define EQUALRECT(R,S) (*((long*)TOPLEFT(R)) == *((long*)TOPLEFT(S))) &&\
			(*((long*)BOTRIGHT(R)) == *((long*)BOTRIGHT(S))) ? true : false
#define PTINRECT(P,R)\
	((P.h>=(R)->left)&&(P.h<=(R)->right)&&(P.v>=(R)->top)&&(P.v<=(R)->bottom)?true:false)
#define SETPT(P,H,V) {(P)->h=H;(P)->v=V;}

