/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1993  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	<sound.h>
#include	<picker.h>
#include	<SANE.h>

typedef struct {
	Rect		userState, stdState;
	Boolean		buttonState;
} WSDRecord, *WSDPointer, **WSDHandle;

//	#define		bwDebugOnColor

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
void BiancoENero ();
long myMenuKey(char key);
void UpdateAll();
void DoWZoom(short zoomDir);
#include	"BobsEyesGlobals.h"

extern	short	gTicksToWait;
extern short  appRefNum;

short	timesToMaxMem;

/* ora inizia il codice vero e proprio */
main ()
{
	MaxApplZone();
	Initialize();
	EventLoop();
}

/* raccogli gli eventi e processali tramite DoEvent */
void EventLoop()
{
	Boolean		ignoreResult;
	EventRecord event;
	
	do {
		if ( gHasWaitNextEvent )
			ignoreResult = WaitNextEvent (0xFFFF, &event, gTicksToWait, 0L);
		else {
			SystemTask();
			ignoreResult = GetNextEvent (everyEvent, &event );
		}

		gOldMouse = gMouse;
		gMouse = event.where;
		DoEvent(&event);

	} while (true);  /* forever */
} /* EventLoop */

/*	fai la cosa giusta per ogni evento (frase citata da PGMF) */
void DoEvent(event)
	EventRecord	*event;
{
	short		part,i;
	char		key;
	Rect		tempRect;
	long		ignore;
	Point		aPoint;

	DoMovedOrIdleMouse(event->where);
	switch (event->what) {
		case activateEvt:
			theWindow = (WindowPtr) event->message;
		//	if ( ( event->modifiers & activeFlag) != 0)
		//		DoActivate ();
		//	else
		//		DoDeactivate ();
			DoActivateDeactivate ();
			break;
		case updateEvt:
			theWindow = (WindowPtr) event->message;
			DoUpdate ();
			break;
		case diskEvt:	/* gestisci i diskEvt... cosi' l'utente puo' formattare un dischetto */
#define kDITop					0x0050
#define kDILeft					0x0070
			if ( HiWord(event->message) != noErr ) {
				SETPT(&aPoint, kDILeft, kDITop);
				(void) DIBadMount(aPoint, event->message);
			}
			break;
		case mouseDown:
			WakeAllTheSleepy();
			theWindow = (WindowPtr) event->message;
			part = FindWindow(event->where, &theWindow);
			switch (part) {
				case inMenuBar:
					{
						MenuHandle menu = GetMHandle(132);
						AdjustMenus();
						((short*)(*menu))[16] = gSoLowToSleep;
						DoMenuCommand(MenuSelect(event->where));
						break;
					}
				case inSysWindow:
					SystemClick(event, theWindow);
					break;
				case inContent:
					if ( theWindow != FrontWindow() ) {
						if ( IsAppWindow(theWindow) && ( (event->modifiers & cmdKey) != 0) ) {
							SelectWindow(theWindow);
							if ( ! EmptyRgn( ((WindowRecord *)theWindow)->updateRgn ) ) DoUpdate ();
							DragWindow(theWindow, event->where, &screenBits.bounds);
							UpdateAll();
						} else {
							SelectWindow(theWindow);
							if ( ! EmptyRgn( ((WindowRecord *)theWindow)->updateRgn ) ) DoUpdate ();
							DoEvent(event);
						}
					} else {
						if ( (event->modifiers & cmdKey) != 0 )
						{
							DragWindow(theWindow, event->where, &screenBits.bounds);
							UpdateAll();
						}
						else if ( (event->modifiers & optionKey) != 0 )
						{
							DoGrow(event);
						}
						else
						{
							char	pupilla;
							if ( pupilla = ((EyesPeek) theWindow)->inPupilla ) {
								BuaAllOcchio ( (Boolean) (pupilla - 1), iniziata);
								if ( gNumSounds ) {
								// 1.1 : il suono va in memoria
									short	num = rand() % gNumSounds;
								//	Handle theHandle = gTheSounds[ num ];
									UseResFile(appRefNum);
									gTheSounds[num] = Get1Resource('snd ',gSoundIDs[num]);
								//	LoadResource(gTheSounds[num]);
									HLock(gTheSounds[num]);
									SndPlay(0L, gTheSounds[num] , false);
									HUnlock(gTheSounds[num]);
								} else
								// malinconico bip
									SysBeep(30);
								BuaAllOcchio ( (Boolean) (pupilla - 1), finita);
							} else {
								DragWindow(theWindow, event->where, &screenBits.bounds);
								UpdateAll();
							}
						}
					}
					break;
				}
			break;
		case autoKey:
		case keyDown:
			key = event->message & charCodeMask;
			if ( (event->modifiers & cmdKey) != 0 ) {
					/* command-key down */
				if ( event->what == keyDown ) {
						AdjustMenus();
						DoMenuCommand(myMenuKey(key));
				}
			}
			break;
		case osEvent:	// una piccola pulizia
			switch (( event->message >> 24) && 0xFF) {
				case suspendResumeMessage:
					theWindow = FrontWindow();
					if ( event->message & resumeMask ) {
							gInBackground = false;
							DoActivate ();
							UpdateAll();
					} else {
							gInBackground = true;
							DoDeactivate ();
					}
					break;
				}
		break;			
		default:
			break;
	}

} /* DoEvent */

/*	esegui la cosa giusta secondo il comando da menu' */
void DoMenuCommand(menuResult)
	register	long		menuResult;
{
	register	short		menuID;
	register	short		menuItem;
	register	short		itemHit;
	Str255		daName;
	short		daRefNum;
	OSErr		error;
	OSErr		ignoreResult;
	RGBColor	color;
	Point 		point;
	Rect		windowRect, portR;
	
	WakeAllTheSleepy();
	theWindow = FrontWindow();
	* ((long *) &point) = 0L;
//	point.v = 0;	
//	point.h = 0;
	asm {
		myHiWrd(menuResult, menuID);
		myLoWrd(menuResult, menuItem);
	}
	switch (menuID) {
		case mApple:
				switch ( menuItem) {
						case iAbout:
							itemHit = Alert(rAboutAlert, 0L);
							break;
						case iHelp:
							itemHit = Alert(rHelpAlert, 0L);
							break;
						default:
							GetItem(GetMHandle(mApple), menuItem, &daName);
							daRefNum = OpenDeskAcc(&daName);
							break;
				}
				break;
		case mFile:
				switch (menuItem) {
						case iNew:
							DoNew();
							break;
						case iClose:
							DoCloseWindow ();
							break;
						case iSave:
							DoSaveSettings();
							break;
						case iQuit:
							Terminate();
							break;
				}
				break;
		case mColors:  /* cambia i colori secondo le richieste dell'utente */
			if (gNumEyeballWindows) {	// non dovrebbe essere abilitato
										// se ( ! theWorld.hasColorQD )
				RGBColor	saveColor;
				register Boolean GotColor = false;
				(void) CompactMem ( 30000 );
				switch (menuItem) {
					case iPupilla:
						color = ((EyesPeek) theWindow)->pupillaColor;
						saveColor = color;
						if ( GotColor = GetColor(point, (ConstStr255Param)&"\pPupil Color", &color, &saveColor))
							((EyesPeek) theWindow)->pupillaColor = saveColor;
						break;
					case iGlobo:
						color = ((EyesPeek) theWindow)->globoColor;
						saveColor = color;
						if ( GotColor = GetColor(point, (ConstStr255Param)&"\pGlobe Color", &color, &saveColor))
							((EyesPeek) theWindow)->globoColor = saveColor;
						break;
					case iBordo:
						color = ((EyesPeek) theWindow)->bordoColor;
						saveColor = color;
						if ( GotColor = GetColor(point, (ConstStr255Param)&"\pBorder Color", &color, &saveColor))
							((EyesPeek) theWindow)->bordoColor = saveColor;
						break;
					}
				if ( GotColor ) {
					InvalRect ( & theWindow->portRect );
					DoUpdate ();
				}
			}
			break;
		case mWindows:
			switch (menuItem) {
				case iSendBack:
					if ( theWindow )
						SendBehind ( theWindow, 0L );
					break;
				case 2:
					if (! theWindow ) break;
					SetPort(theWindow);
					windowRect = (*theWindow).portRect;
					/*	this code should not stay here, but in the WDEF.
						anyway, since we do not have a zoom box, when would this
						code be called ? */
					/* a fix for CWindowRecords */
					if ((theWindow->portBits.rowBytes & (3<<14)) == 0) {
						OFFSETRECT( &windowRect, -theWindow->portBits.bounds.left, -theWindow->portBits.bounds.top );
					} else {
						portR = (**(*(CGrafPtr)theWindow).portPixMap).bounds;
						OFFSETRECT(&windowRect, -portR.left, -portR.top);
					}
					
					if ( EQUALRECT (
						&((**(WSDHandle)(*(WindowPeek)theWindow).dataHandle).stdState),
						&windowRect
					) )
						DoZoom(inZoomIn);
					else {
						(**(WSDHandle)(*(WindowPeek)theWindow).dataHandle).userState 
						= windowRect;
						DoZoom(inZoomOut);
					}
					break;
				default:
					PopWindow ( menuItem - 1 );
					break;
			}
			break;
		case 132:
			if (menuItem) {
				gSoLowToSleep = menuItem;	// very facile non \`e cos\`\i\ ?
			}
			break;
	}
	HiliteMenu(0);
} /* DoMenuCommand */

/* Abilita e disabilita i menu secondo bisogno */
void AdjustMenus()
{
	register	WindowPtr	frontmost;
	register	MenuHandle	menu;
	short		i;
		
	frontmost = FrontWindow();
	menu = GetMHandle(mFile);
	
	if ( gNumEyeballWindows < maxOpenEyeballWindows )
		EnableItem(menu, iNew);
	else
		DisableItem(menu, iNew);
	
	if (frontmost != 0L)
		EnableItem(menu, iClose);
	else
		DisableItem(menu, iClose);
	
	menu = GetMHandle(mColors);
	if ( ( gNumEyeballWindows == 0 ) || ( ! theWorld.hasColorQD ) )
		DisableItem (menu, 0);
	else
		EnableItem (menu, 0);
	
	menu = GetMHandle(mWindows);
	if (gNumEyeballWindows)
	{
		for (i = 1; i <= maxOpenEyeballWindows; i++)
			if (i <= gNumEyeballWindows)
				EnableItem (menu, i+2);
			else
				DisableItem(menu, i+2);

		if ( gNumEyeballWindows < 2 )
			DisableItem (menu, iSendBack);
		else
			EnableItem (menu, iSendBack);
	}
	else
		DisableItem(menu,0);
	
	menu = GetMHandle(132);
	if (gNumEyeballWindows)
		EnableItem(menu,0);
	else
		DisableItem(menu,0);

	DrawMenuBar();	/* heh ! */

} /* AdjustMenus */


/* gestisci eventi di Activate e Deactivate */
void DoActivateDeactivate () {
	/* nothing to do to the window */
}


/* quando il mouse si muove bisogna vedere se e' il caso di ridisegnare le pupille */
void DoMovedOrIdleMouse(point)
	Point	point;
{
	if ( ((long)(*(long*)(&gOldMouse))) != ((long)(*(long*)(&point))) ) {
/*	to save 10 bytes of code and to learn how to drive mad who reads it */
/*	if ( (gOldMouse.h != point.h) || (gOldMouse.v != point.v) ) {	*/
		WakeAllTheSleepy();
		EraseDrawAllPupils(FrontWindow());
	} else
		SendToSleep();

}	/* DoMovedOrIdleMouse */


/*	nuova visione */
void DoNew()
{
	Boolean		good;
	Ptr			storage;
	RGBColor	*color;
	Rect		newRect;
	
	SETRECT ( & newRect,36,48,186,168);
	storage = NewPtr(sizeof(EyesRecord));
	if (storage != 0L) {

		WakeAllTheSleepy();

		theWindow = ( (WindowPtr) (*newwindowproc) (
							(void *)storage , & newRect , "\pBob's Eyes Pro",
							true, 328 , (WindowPtr)-1L, true, 0L) );

		if ( theWindow != 0L ) {
			SetPort(theWindow);
			((EyesPeek) theWindow)->posizione = 0;
			gNumEyeballWindows += 1;
			if ( theWorld.hasColorQD ) {

			//	color = &((EyesPeek) theWindow)->sfondoColor;
			//	color->red = color->green = color->blue = 0xB0FF;
			//	Sfondo ( );

				color = &((EyesPeek) theWindow)->bordoColor;
				color->red = color->green = 0x0000; color->blue = 0xD400;

				color = &((EyesPeek) theWindow)->globoColor;
				color->red = 0xFC00;	color->green = 0xF37D;	color->blue = 0x052F;

				color = &((EyesPeek) theWindow)->pupillaColor;
				color->red = 0xDD6B;	color->green = 0x08C2;	color->blue = 0x06A2;
			} // else {
//	no meaning for this with new WDEF
//				BackPat ( &qd.white );
//			}
			CalcWindowSizes ();
			CalcPupilPos();
			InvalRect (&theWindow->portRect);
			DoUpdate ();
		} else
			DisposPtr(storage);
	}
	AdjustMenus();
} /* DoNew */


/* cambiamento di dimensione della finestra */
void DoGrow(event)
	EventRecord *event;
{
	Rect		sizeRect;
	register	long	newSize;
	register	short	newWidth,newHeight;
	
	SETRECT (&sizeRect,MINWIDTH,MINHEIGHT,MAXWIDTH,MAXHEIGHT);
	SetPort ( theWindow );
	if ( newSize = GrowWindow(theWindow, event->where, &sizeRect) ) {
		asm {
			myLoWrd(newSize,newWidth);
			myHiWrd(newSize,newHeight);
		}
		SizeWindow (theWindow, newWidth, newHeight, true);
		CalcWindowSizes ();
		CalcPupilPos ();
		InvalRect(&theWindow->portRect);
		DoUpdate ();
	}
} /* DoGrow */

/* Zoom della finestra a tutto schermo ( effetto malinconico ) */
void DoZoom( short inOrOut )
{
	SetPort ( theWindow );
	DoWZoom ( inOrOut );
	CalcWindowSizes ();
	CalcPupilPos ();
	InvalRect (&theWindow->portRect);
	DoUpdate ();
}  /* DoZoom */

/*	prende la which-esima finestra : non la which-esima finestra
	aperta dall'utente ma la which-esima in profondita' */
void PopWindow(register	short	which)
{
	register	short	i;
	
	theWindow = FrontWindow();
	if (theWindow) {
		for (i = 1; i < which; i++) {
			theWindow = NextWindow(theWindow);
			if (theWindow == 0L) break;
		}
		if (theWindow) SelectWindow(theWindow);
	}
}

/* uccidiamo un paio di occhi oppure chiudiamo un DA */
Boolean DoCloseWindow()
{
	if ( IsDAWindow(theWindow) )
		CloseDeskAcc(((WindowPeek) theWindow)->windowKind);
	else if ( IsAppWindow(theWindow) ) {
		CloseWindow(theWindow);
		DisposPtr((Ptr) theWindow);
		gNumEyeballWindows -= 1;
		AdjustMenus();
	}	
	return true;
} /* DoCloseWindow */
 
/*	prevents from searching the Sleep Menu ... */
long myMenuKey(char key)
{
	long result;
	MenuHandle menu = GetMHandle(132);
	DisableItem(menu,0);
	result = MenuKey(key);
	if (gNumEyeballWindows) EnableItem(menu,0);
	return result;
}	/* myMenuKey */
