/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1992  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
void BiancoENero ();

void UpdateAll();
#include	"ExternGlobals.h"

/*	serve ad aggiornare il contenuto di una finestra quando il sistema operativo
	segnale che parte di essa o tutta quanta non necessariamente contiene
	quanto scritto/disegnato prima */

void DoUpdate ()
{
	RGBColor	color;
	
   	if ( IsAppWindow(theWindow) )
		if ( ! EmptyRgn(theWindow->visRgn) ) {
			SetPort( theWindow );
			BeginUpdate( theWindow );					
				myDeviceLoop ( (RgnHandle) &theWindow->visRgn,
						(myDeviceLoopDrawingProcPtr) &myDoUpdateDrawingProc, 0L);
			EndUpdate( theWindow);
			CalcPupilPos () ;
		}
} /* DoUpdate */

void UpdateAll()
{
	WindowPtr	thisWindow,nextWindow;
	
	nextWindow = thisWindow = FrontWindow();
	while ( nextWindow != nil ) {
		nextWindow = NextWindow(thisWindow);
		if ( IsAppWindow (thisWindow) ) {
			if ( ! EmptyRgn ( ( (WindowPeek) thisWindow)->updateRgn) ) {
				theWindow = thisWindow;
				DoUpdate();
			}
		}
		thisWindow = nextWindow;
	}	// while
}

pascal void myDoUpdateDrawingProc (
	short		depth,
	GDHandle	targetDevice,
	long		userdata )
{
	gForcedBW = ( depth < 3 ) ;
	Sfondo ( );
	EraseRect (&theWindow->portRect);
	DrawGlobes ( );
	DrawOnlyPupil ( );
}	/* myDoUpdateDrawingProc */

/*	disegna i globi oculari. Non disegna le pupille */
void DrawGlobes ()
{
	Rect		inRect;
	short		rectWidth;

	SetPort (theWindow);
	rectWidth = ((EyesPeek) theWindow)->rectDim.h;
	
	inRect = ((EyesPeek) theWindow)->eyeRect;
	Bordo ();
	PaintOval(&inRect);
	inRect.left += ((EyesPeek) theWindow)->offset;
	inRect.right += ((EyesPeek) theWindow)->offset;
    PaintOval(&inRect);
    
   	inRect = ((EyesPeek) theWindow)->globeRect;
	Globo ();
	PaintOval(&inRect);
	inRect.left += ((EyesPeek) theWindow)->offset;
	inRect.right += ((EyesPeek) theWindow)->offset;
    PaintOval(&inRect);    

} /* DrawGlobes */

void DrawOnlyPupil ()
{
	char posizione;
	
	SetPort(theWindow);
	if ( ( posizione = ((EyesPeek) theWindow)->posizione) != 16 ) {
		DrawOnlyPupilOne ( &((EyesPeek) theWindow)->left );
		DrawOnlyPupilOne ( &((EyesPeek) theWindow)->right );	
	}
	if ( posizione ) AbbassaLePalpebre ();
}

void DrawOnlyPupilOne( register	PCouplePtr  couple)
{
	Point	pupilRay;
	Rect	inRect;
	Point	pupilCentre;
	
	pupilRay = ((EyesPeek) theWindow)->pupilRay;
	pupilCentre = couple->new;
	SetRect ( &inRect , pupilCentre.h - pupilRay.h,
						pupilCentre.v - pupilRay.v,
						pupilCentre.h + pupilRay.h,
						pupilCentre.v + pupilRay.v);
	Pupilla ();
	PaintOval (&inRect);
	couple->old = pupilCentre;
}
