/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1993  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
#include	"ExternGlobals.h"

void DoWZoom(short zoomDir)
{
	register GDHandle nthDevice, dominantGDevice;
	register long	  sectArea;
	register long	  greatestArea;
	register short	  bias;
	Rect	globalPortRect, theSect, zoomRect;
	Rect* rectp;

	//	If there is the possibility of multiple gDevices, then we
	//	must check them to make sure we are zooming onto the right
	//	display device when zooming out.
	if (zoomDir == inZoomOut)
	{
		if ( theWorld.hasColorQD )
		{
			globalPortRect = theWindow->portRect;
			LocalToGlobal( & ( (Point *) & globalPortRect ) [0] );
			LocalToGlobal( & ( (Point *) & globalPortRect ) [1] );
			bias = globalPortRect.top - 3	// this one is adapted for the new WDEF
					- (**( ((WindowPeek)theWindow) -> strucRgn)).rgnBBox.top;
	
			dominantGDevice = nthDevice = GetDeviceList();
			greatestArea = 0;
	
		//	This loop checks the window against all the gdRects in the gDevice list and remembers
		//	which gdRect contains the largest portion of the window being zoomed.
	
			while  ( nthDevice != nil ) {
	
				if ( SectRect(&globalPortRect,&(**nthDevice).gdRect,&theSect) ) {
					sectArea = ((long)(theSect.right-theSect.left))*((long)(theSect.bottom-theSect.top));
					if ( sectArea > greatestArea ) {
						greatestArea = sectArea;
						dominantGDevice = nthDevice;
					}
				}	//	se c'e' intersezione controllo altrimenti e' inutile
				nthDevice = GetNextDevice(nthDevice);
	
			}	// end of while
			//	We must create a zoom rectangle manually in this case.
			//	account for menu bar height as well, if on main device
			if ( dominantGDevice == GetMainDevice() )
				bias += GetMBarHeight() ;
			{
				rectp = & (**dominantGDevice).gdRect;
				SETRECT(&zoomRect,
							rectp->left+5,
							rectp->top+bias+5,
							rectp->right-5,
							rectp->bottom-5);	// adapted for the new WDEF
			}
		}	// if ( theWorld.hasColorQD )
		else // good ol' 8 color QD (8 color,ImageWriter, BW screen, I mean, not 8-bit)
		{
			zoomRect = screenBits.bounds;
			INSETRECT(&zoomRect,5,5);
			zoomRect.top += 20;	// the menu bar ...
		}

		//	Set up the WStateData record for this window.
		//	2.1 of 04/12/92 But, for Bob's Eyes Pro we do not allow windows to be
		//	larger than MAXWIDTH x MAXHEIGHT pixels. why ? the regions would then
		//	become too large and the whole system may crash. sometimes the system
		//	survives but Bob's Eyes Pro dies with error 25: that is OUT OF MEMORY
		
		{
			short	excess;
			
			if ( ( excess = zoomRect.right - zoomRect.left - MAXWIDTH ) > 0 )
			{
				zoomRect.left += (1 + excess >> 1);
				zoomRect.right -= (1 + excess >> 1);
			}

			if ( ( excess = zoomRect.bottom - zoomRect.top - MAXHEIGHT ) > 0 )
			{
				zoomRect.top += (1 + excess >> 1);
				zoomRect.bottom -= (1 + excess >> 1);
			}
		}

		(**(WStateDataHandle)(((WindowPeek)theWindow)->dataHandle)).stdState = zoomRect;

	}

	// and then ...
	ZoomWindow(theWindow,zoomDir,true);

}
