/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1992  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	<sound.h>

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
#include	"ExternGlobals.h"

extern	short	timesToMaxMem;
short	gTicksToWait;
short		prefsFileRefNum,appRefNum;

#define	min(A,B) (A>B)?B:A
#define	max(A,B) (A>B)?A:B

/* inizializzazione (parola orribile) del programma */
void Initialize()
{
	OSErr		ignoreError, error;
	EventRecord	dummyEvent;
	short		i,resErr;
	short		**sleeper;
	Ptr			storage;
	WinCTab		**wctbH;
	Boolean		ok;
	char		padString[255];
	short		resID;
	long		resType;

	FlushEvents (everyEvent - diskMask, 0 );
	gInBackground = false;
	InitGraf((Ptr) &thePort);
	InitFonts();
	InitWindows();
	InitMenus();
	InitDialogs(0L);
	InitCursor();
	
	MoreMasters ();
	MoreMasters ();
	MoreMasters ();

	(void) PurgeMem(50000);
	prefsFileRefNum = -1;
	timesToMaxMem = 60;
	ignoreError = SysEnvirons (sysEnvironsVersion, &theWorld);
	if (theWorld.machineType < 0)
		gHasWaitNextEvent = false;
	else
		/* _WaitNextEvent = 0xA860 */
		gHasWaitNextEvent = TrapAvailable(0xA860, ToolTrap);

//	#define bwDebugOnColor
#ifdef	bwDebugOnColor
	theWorld.hasColorQD = false;
#endif

	if (theWorld.hasColorQD)							// NewCWindow
		newwindowproc = (NewWindowProcPtr) NGetTrapAddress(0xAA45,ToolTrap);
	else												// NewWindow
		newwindowproc = (NewWindowProcPtr) NGetTrapAddress(0xA913,ToolTrap);

	appRefNum = CurResFile();
	CouldAlert(rCouldNotLoadSound);
	CouldAlert(rNotEnoughMemory);
	for ( i = 0; i < 8; i ++ ) gTheSounds[i] = 0L;
	i = Count1Resources('snd ');	// there is at least one sound
	if ( i > 8 ) i = 8;
	gNumSounds = 0;
	while ( gNumSounds < i ) {	// load at most 8 sounds
		gNumSounds++;
		gTheSounds[gNumSounds - 1] = Get1IndResource('snd ',gNumSounds);
		GetResInfo(gTheSounds[gNumSounds - 1],&resID,&resType,&padString);
		gSoundIDs[gNumSounds - 1] = resID;
		MoveHHi(gTheSounds[gNumSounds - 1]);
		resErr = ResError();
		if (resErr) {
			(void) StopAlert(rCouldNotLoadSound,0L);
			Terminate();
		}	
	}
	if (FreeMem() < 36000 ) {
		(void) StopAlert(rNotEnoughMemory,0L);	
		Terminate();
	}
	FreeAlert(rCouldNotLoadSound);
	FreeAlert(rNotEnoughMemory);
	
	if ( ! ( sleeper = (short **) GetResource ('rAnd', 128) ) ) {
		gTicksToWait = 3;
		gSoLowToSleep = 2000;
	} else {
		gSoLowToSleep = **sleeper++;
		i = **sleeper;
		gTicksToWait = min ( 6, max ( i , 1 ) );
		DetachResource ((Handle) sleeper);
	}
	if ( theWorld.hasColorQD )	
	if ( wctbH = (WinCTab **) GetResource ('wctb', 128) )
		SetWinColor ( 0L , wctbH ) ;

	gBlack.red = 0x0000;
	gBlack.green = 0x0000;
	gBlack.blue = 0x0000;
	gWhite.red = 0xffff;
	gWhite.green = 0xffff;
	gWhite.blue = 0xffff;

	SETRECT(&gEnormousRect,-32000,-32000,32000,32000);
	SetMenuBar(GetNewMBar(rMenuBar));
	AddResMenu(GetMHandle(mApple), 'DRVR');
	(void) GetResource('MENU',132);	// a fix for a strange behaviour
	DrawMenuBar();
	
	eYeS_H = 0L;
	gNumEyeballWindows = 0;

	for (i = 0; i < 3; i++) gMyRgn[i]=NewRgn();  /* set-up delle regioni */

	if ( ! ( error = FindPrefsFile(&prefsFileRefNum) ) )
	{
		if ( ( eYeS_H = (eYeSHandle) GetResource ('eYeS', 128) ) ) {
			short		quante;
			eYeSWinPeek	theWinData;
	
			MoveHHi (eYeS_H);
			HLock (eYeS_H);
			HNoPurge (eYeS_H);
			quante = (**eYeS_H).quante;
			gSoLowToSleep = (**eYeS_H).valore;
			for (i = 0; i < quante; i++) {
				if ( storage = NewPtr(sizeof(EyesRecord)) ) {
					theWinData = & ((**eYeS_H).eYeSWin[i]);
					theWindow = ( (WindowPtr) (*newwindowproc) (
									storage , & theWinData->rect , "\pBob's Eyes Pro",
									true, 328 , (WindowPtr)-1L, true, 0L) );
					if ( theWindow ) {
						((EyesPeek) theWindow)->colori = theWinData->colori;
						((EyesPeek) theWindow)->posizione = 0;
						SetPort (theWindow);
						( * (long *) & gOldMouse ) = 0L;
						GetMouse ( &gMouse );
						LocalToGlobal ( &gMouse );
						CalcWindowSizes ();
						CalcPupilPos ();
						myDeviceLoop ( (RgnHandle) &theWindow->visRgn,
								(myDeviceLoopDrawingProcPtr) &myDoUpdateDrawingProc, 0L);
						gNumEyeballWindows ++;
					}
				}
			}
			HUnlock (eYeS_H);
		}
	} else
		prefsFileRefNum = -1;
		
	if ( ! gNumEyeballWindows )	DoNew();

	/* questo affinche' multifinder si accorga che esisto ..... (TN 180) */
	for	(i = 0; i < 15; i++) (void) EventAvail (everyEvent, &dummyEvent);
	srand ( 10101 );
	
} /* Initialize */

/* Fine del programma */
void Terminate()
{
	WindowPtr	aWindow;
	Boolean		closed;
	short		i;

	closed = true;
	do {		// per essere gentili nei confronti dei DA
		aWindow = FrontWindow();				/* get the current front window */
		if (aWindow != nil) {
			theWindow = aWindow;
			closed = DoCloseWindow ();	// close this window
		}
	}	while (closed && (aWindow != nil));
	if (closed) {
		for (i = 0; i < 3; i++) if ( gMyRgn[i] ) DisposeRgn ( gMyRgn[i] );

		if ( prefsFileRefNum != -1 ) CloseResFile(prefsFileRefNum);
		ExitToShell();
	}

} /*Terminate*/
