/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1992  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
#include	"ExternGlobals.h"

void EraseDrawAllPupils(WindowPtr window)
{
	if ( window ) {
		EraseDrawAllPupils(NextWindow(window));
		if ( IsAppWindow ( window ) ) {
			theWindow = window;
			EraseDrawPupil ();
		}
	}
} /* EraseDrawAllPupils */


/* disegna le pupille di una data finestra ( sono state cancellate ) */
void EraseDrawPupil ()
{
	SetPort (theWindow);
	CalcPupilPos ();
	DrawPupil ();
} /* EraseDrawPupil */


// 	procedure to draw the pupils at the right places whenever they change position
void DrawPupil ( )
{
	char posizione;
	
	SetPort(theWindow);
	if ( ( posizione = ((EyesPeek) theWindow)->posizione) != 16 ) {
		DrawPupilOne ( &((EyesPeek) theWindow)->left );
		DrawPupilOne ( &((EyesPeek) theWindow)->right );
	}
	if ( posizione ) AbbassaLePalpebre ();
	
}	/* DrawPupil */

/*	SubRoutine di DrawPupil per disegnare UNA pupilla al bisogno */
void DrawPupilOne ( PCouplePtr  couple )
{
	Point	pupilRay;
	Rect	inRect;
	Point	oldPoint, pupilCentre;
	
	pupilRay = ((EyesPeek) theWindow)->pupilRay;
	oldPoint = couple->old;
	pupilCentre = couple->new;

	/*	uso le regioni (Regions) per disegnare le pupille nelle
		nuove posizioni : in questo modo evito il fastidioso
		sfarfallio dello schermo e mi comporto meglio degli occhi
		sotto X-windows oppure sotto windowsIII (bleah).
		gMyRgn[0] contiene l'outline della pupilla nella vecchia posizione.
		gMyRgn[1] contiene quella della nuova posizione.
		con la prima DiffRgn determino l'area da dipingere della pupilla
		nella nuova posizione che non fa parte della pupilla prima,
		con la seconda DiffRgn determino l'area da cancellare che appartiene
		alla vecchia pupilla ma non a quella nuova. */
	if ( (oldPoint.h != pupilCentre.h) || (oldPoint.v != pupilCentre.v) )
	{
		OpenRgn();
			SETRECT(&inRect, oldPoint.h - pupilRay.h,
							oldPoint.v - pupilRay.v,
							oldPoint.h + pupilRay.h,
							oldPoint.v + pupilRay.v);
			FrameOval(&inRect);
		CloseRgn(gMyRgn[0]); /* vecchia pupilla */
		OpenRgn();
			SETRECT(&inRect, pupilCentre.h - pupilRay.h,
							pupilCentre.v - pupilRay.v,
							pupilCentre.h + pupilRay.h,
							pupilCentre.v + pupilRay.v);
			FrameOval(&inRect);
		CloseRgn(gMyRgn[1]);  /* nuova pupilla */
		DiffRgn(gMyRgn[1], gMyRgn[0], gMyRgn[2]);
		DiffRgn(gMyRgn[0], gMyRgn[1], gMyRgn[1]);

		// disegna la parte nuova di pupilla : 2  il numero della regione
		myDeviceLoop ( (RgnHandle) theWindow->visRgn, myDrawPupilOneProc, (long) 2 );

		// cancella la parte vecchia : 1  il numero della regione
		myDeviceLoop ( (RgnHandle) theWindow->visRgn, myDrawPupilOneProc, (long) 1 );
	}
	couple->old = pupilCentre;

	// per risparmiare memoria ( v 1.1.11 )
	SetEmptyRgn(gMyRgn[0]);
	SetEmptyRgn(gMyRgn[1]);
	SetEmptyRgn(gMyRgn[2]);

}  /* DrawPupilOne */

pascal void myDrawPupilOneProc (short depth, GDHandle targetDevice, long userdata)
{
	gForcedBW = (depth < 3);
	switch (userdata) {
		case 1:
			Globo ();
			PaintRgn(gMyRgn[1]);   /* cancella la parte vecchia */
			break;
		case 2:
			Pupilla ();
			PaintRgn(gMyRgn[2]);   /* disegna la parte nuova di pupilla */
			break;
	}
}
