/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1992  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
#include	"ExternGlobals.h"

void SendToSleep()
{
	WindowPtr	saveWindow = theWindow;
	SendToSleepBehind(FrontWindow());
	theWindow = saveWindow;
}

void SendToSleepBehind(register WindowPtr window)
{
	if (window) {
		SendToSleepBehind(NextWindow(window));
		if (IsAppWindow(window)) {
			if ( ! ((EyesPeek) window)->posizione ) {
				if ( rand() < (gSoLowToSleep / gNumEyeballWindows ) ) {
					((EyesPeek) window)->posizione = 1;
					theWindow = window;
					AbbassaLePalpebre ();
				}
			} else if ( ((EyesPeek) window)->posizione < 16 ) {
				((EyesPeek) window)->posizione ++ ;
				theWindow = window;
				AbbassaLePalpebre ();
			}
		}	// if isappwindow
	}
} /* SendToSleepOne */

void AbbassaLePalpebre ()
{
	Rect	inRect;
	short	rectH, hRectH, nhRectH, nRectH, rectWidth;
	char	posizione, pos2;
	short	temp;
	
	SetPort(theWindow);
	inRect = ((EyesPeek) theWindow)->globeRect;
	rectWidth = ((EyesPeek) theWindow)->rectDim.h;
	temp = (19+rectWidth) >> 5;	// a little cosmetic improvement
	INSETRECT(&inRect,-temp,0);
	OpenRgn();
		FrameOval(&inRect);
	CloseRgn(gMyRgn[0]);
	hRectH = (rectH = inRect.bottom - inRect.top) >> 1;
	posizione = ((EyesPeek) theWindow)->posizione;
	
	OpenRgn();
		inRect.bottom -= hRectH;
		FrameRect(&inRect);
		inRect.bottom += hRectH;
	CloseRgn(gMyRgn[1]);
	SectRgn(gMyRgn[0], gMyRgn[1], gMyRgn[0]);
	
	if ( (pos2 = posizione) > 8) pos2 = 16 - posizione;
	nhRectH = (hRectH * (8 - pos2)) >> 3;
	inRect.top += (hRectH - nhRectH);
	inRect.bottom -= (hRectH - nhRectH);
	OpenRgn();
		FrameOval(&inRect);
	CloseRgn(gMyRgn[1]);
	if (posizione <= 8)
		DiffRgn(gMyRgn[0], gMyRgn[1], gMyRgn[0]);
	else
		UnionRgn(gMyRgn[0], gMyRgn[1], gMyRgn[0]);

	myDeviceLoop( (RgnHandle) theWindow->visRgn , myAbbassaLePalpebreProc , 0L);

	OffsetRgn(gMyRgn[0], ((EyesPeek) theWindow)->offset, 0);

	myDeviceLoop( (RgnHandle) theWindow->visRgn , myAbbassaLePalpebreProc , 0L);

	// per risparmiare memoria ( v 1.1.11 )
	SetEmptyRgn(gMyRgn[0]);
	SetEmptyRgn(gMyRgn[1]);
	SetEmptyRgn(gMyRgn[2]);
	
}	/* AbbassaLePalpebre */

pascal void myAbbassaLePalpebreProc ( short depth, GDHandle targetDevice, long userdata )
{
	gForcedBW = (depth < 3);
	Bordo ();
	PaintRgn(gMyRgn[0]);
}	/* myAbbassaLePalpebreProc */

void WakeAllTheSleepy()
{
	WindowPtr	saveWindow = theWindow;
	WakeAllTheSleepyBehind(FrontWindow());
	theWindow = saveWindow;
} /* WakeAllTheSleepy */

void WakeAllTheSleepyBehind(register WindowPtr window)
{
	if (window) {
		WakeAllTheSleepyBehind(NextWindow(window));
		WakeTheSleepy(window);
	}
} /* WakeAllTheSleepyOne */

void WakeTheSleepy(register WindowPtr window)
{
	if ( IsAppWindow ( window ) )
		if ( ((EyesPeek) window)->posizione ) {
			((EyesPeek) window)->posizione = 0;
			theWindow = window;
			myDeviceLoop( (RgnHandle) theWindow->visRgn , myWakeUpProc , 0L );
		}
} /* WakeTheSleepy */

pascal void myWakeUpProc (short depth, GDHandle targetDevice, long userdata)
{
	gForcedBW = (depth < 3);
	DrawGlobes ();
	CalcPupilPos ();
	DrawOnlyPupil ();
}	/* myWakeUpProc */
