/*
    BOB'S EYES PRO version 2
    Copyright (C) 1991-1993  Roberto Avanzi

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

	Author's Address:
		Roberto Avanzi
		via Luigi Balzan 12
		45100 Rovigo (RO)
		Italy (EEC)
	
	Internet E-Mail Address: (at least for 1992)
		gandalf@sabrina.dei.unipd.it
		caraccio@libertad.physics.nyu.edu (alternate one)
*/

#include	"BobsEyesDefsStructs.h"
#include	"BobsEyesProtos.h"
#include	"ExternGlobals.h"

//	this is an example of a DeviceLoop procedure.

pascal void myDeviceLoop(RgnHandle drawingRgn, myDeviceLoopDrawingProcPtr drawingProc, long userdata)
{
	if ( theWorld.hasColorQD ) {
		GDHandle	nextGDevice, thisGDevice;
		short		thisDeviceDepth;
		Rect		tempRect;
		RgnHandle	clipSave, tempRgn;
		signed char	deviceHState;
		
		clipSave = NewRgn();
		tempRgn = NewRgn();
		SetPort(theWindow);
		GetClip(clipSave);
		nextGDevice = thisGDevice = GetDeviceList ();

		while ( nextGDevice != nil ) {

			nextGDevice = GetNextDevice(thisGDevice);
			if ( TestDeviceAttribute (thisGDevice, screenDevice) &&
					TestDeviceAttribute (thisGDevice, screenActive) ) {

				//	un potenziale errore  fare HLock ... HUnLock se non si sa
				//	con certezza qual  lo stato del Handle che si va a bloccare
				//	molto meglio  HGetState/HLock ... HSetState
				deviceHState = HGetState(thisGDevice);
				HLock(thisGDevice);
				tempRect = (**thisGDevice).gdRect;
				GlobalToLocal ( & topLeft ( tempRect ) );
				GlobalToLocal ( & botRight ( tempRect ) );
				if (RectInRgn (&tempRect,clipSave)) {
					RectRgn (tempRgn, &tempRect);
					SectRgn (clipSave, tempRgn, tempRgn);
					SetClip (tempRgn);
					(* drawingProc)
						( (**(**thisGDevice).gdPMap).pixelSize , thisGDevice , userdata);
				}
				HSetState(thisGDevice, deviceHState);

			}
			thisGDevice = nextGDevice;

		} // while
		SetClip(clipSave);
		DisposeRgn(clipSave);
		DisposeRgn(tempRgn);

	} else

		(* drawingProc) ( 1 , 0L , userdata );

}	/* myDeviceLoop */
